static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0xBE, 0x5E, 0x35, 0xC3, 0xF3, 0xDE, 0xAA, 0x49, 0xE6, 0x9A,
        0x46, 0x52, 0x27, 0x64, 0xC9, 0xB8, 0x65, 0x27, 0x10, 0xBE,
        0x6F, 0x06, 0xCA, 0x5E, 0xAD, 0x34, 0x96, 0x27, 0x3B, 0x34,
        0x49, 0xF5, 0x34, 0x18, 0x1E, 0x98, 0x32, 0x37, 0x7F, 0x2D,
        0x35, 0xBB, 0x9E, 0xDB, 0xEE, 0xAC, 0xA7, 0x6B, 0x81, 0x6E,
        0xE6, 0x24, 0x51, 0x61, 0x0F, 0x5A, 0xD0, 0x1F, 0xAD, 0xE7,
        0xB6, 0x01, 0x2F, 0xC7
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
